module Chervil
  class Parser
    def initialize(lexer)
      @lexer = lexer
      @tree = Array.new
      @current_token = @lexer.get_next_token
    end

    def parse
      until @current_token.type == :eof
        @tree << expr
      end
      @tree
    end

    def expr
      if @current_token.type == :number
        constant
      end
    end

    def constant
      case @current_token.type
      when :number
        token = eat(:number)
        AST::Number.new(token.value.to_f)
      end
    end

    def eat(type)
      if @current_token.type == type
        token = @current_token
        @current_token = @lexer.get_next_token
        token
      else
        raise "Expected #{type} but got #{@current_token.type}"
      end
    end
  end
end
